#ifndef _XMLCONFIG_H
#define _XMLCONFIG_H

#include <libxml/parser.h>
#include <libxml/xpath.h>

typedef struct {
	xmlDocPtr doc; 
	xmlChar *xpath;
	xmlNodeSetPtr nodeset;
	xmlXPathObjectPtr result;
} xmlconfig_t; 

/*
 * Public API
 */
extern xmlconfig_t *xmlconfig_init(const char *filename); 
extern int xmlconfig_finish(xmlconfig_t *cfg);

extern int xmlconfig_get_ulong  (xmlconfig_t *cfg, char *xpath, unsigned long *val, int nelem);
extern int xmlconfig_get_long   (xmlconfig_t *cfg, char *xpath, long *val, int nelem);
extern int xmlconfig_get_double (xmlconfig_t *cfg, char *xpath, double *val, int nelem);
extern int xmlconfig_get_string (xmlconfig_t *cfg, char *xpath, char   *buf, int strlen, int nelem); 

#endif
